// Intially calling functions
$(document).ready(function () {

  //Calling Login function
  login()

  //~ connectMedia();
  $('.showHideBlock').hide()
  $('#playVideo').click(function () {

    stop_a_broadcast()
    $('.videoContainer').html('')
    $('.videoContainer').html('<video id="remoteVideo" muted  webkit-playsinline="true" playsinline="true" autoplay="" style="width:100%;"></video>')
    if (selectedVideoType) {
      broadcast.type = selectedVideoType
    }
    initVideo()
  })
})

//Calling browser api to get the video source url

function initVideo () {
  //Request Data
  var videoSourceUrl = mediaAddress
  //WebRTC
  if (broadcast.type == 'webrtc') {
    var source = 'https://' + videoSourceUrl + '/webrtc/#PEERID#/' + imei + '/' + CameraType + '/' + mediaToken + ''
  } else//HLS
  {
    var source = 'https://' + videoSourceUrl + '/' + imei + '/' + CameraType + '/' + mediaToken + '/' + dashCamVideoFileName
  }
  console.log('initVideo', (mediaAddress, source))
  $('.showHideBlock').show()
  broadcast.source = source
  broadcast.video_element_toggle = true
  $.ajax({
    url: hostName + '/v2/devices/' + imei + '/cameras',
    headers: {
      'Content-Type': 'application/json',
      'Authorization': 'Bearer ' + token
    },
    success: function (data) {
      console.log('deviceCameras:', { data })
      if (data) {
        if (data.data.some(camera => camera.cameraId === CameraType)) {
          alert(source)
          videosource.setAttribute('src', source)
          if (broadcast.type == 'hls') {
            create_video_hls(broadcast)
          } else if (broadcast.type == 'webrtc') {
            create_video_webrtc(broadcast)
          }
        } else {
          alert('Device camera: ' + CameraType + ' is offline.')
        }
      } else {
        alert(data.status.error)
      }
    },
    error: function (error) {
      console.error('Error: deviceCameras:', { error })
      if (error.responseJSON && error.responseJSON.error) {
        alert(error.responseJSON.message || error.responseJSON.error)
      } else {
        alert(error.responseText)
      }
    },
  })
}

//Calling genereate auth token api
function connectMedia () {
  console.log('connectMedia ', { token })
  $.ajax({
    type: 'POST',
    url: hostName + '/v2/devices/' + imei + '/connect-media',
    headers: {
      'Content-Type': 'application/json',
      'Authorization': 'Bearer ' + token
    },
    success: function (data) {
      console.log('connectMedia:', { data })
      if (data) {
        mediaToken = data.data.mediaToken
        mediaAddress = data.data.address
        console.log('connectMedia:', { mediaToken, mediaAddress })
      } else {
        alert(data.status.error)
      }
    }
  })
}

//Play or Pause function
function play_pause_broadcast () {
  if (broadcast.video_status) {
    play_a_broadcast()
    document.getElementById('playPause').value = 'Pause'
  } else {
    stop_a_broadcast()
    document.getElementById('playPause').value = 'Play'
  }
  broadcast.video_status = !broadcast.video_status
}

//video play function
function play_a_broadcast () {
  if (broadcast.type == 'hls') {
    create_video_hls(broadcast)
  } else if (broadcast.type == 'webrtc') {
    create_video_webrtc(broadcast)
  }
}

//Stop video function
function stop_a_broadcast () {
  if (broadcast.type == 'hls') {
    destroy_video_hls('remoteVideo')
  } else if (broadcast.type == 'webrtc') {
    destroy_video_webrtc('remoteVideo')
  }
}

//Video full screen function
function goFullscreen () {
  try {
    elem = videosource
    if (elem.requestFullscreen) {
      elem.requestFullscreen()
    } else if (elem.mozRequestFullScreen) {
      elem.mozRequestFullScreen()
    } else if (elem.webkitRequestFullscreen) {
      elem.webkitRequestFullscreen()
    } else if (elem.webkitEnterFullScreen != undefined) {
      elem.webkitEnterFullScreen()//Safari
    }
  } catch (e) {
  }
}

// Login to get token
function login () {
  //Login API Call
  $.ajax({
    type: 'POST',
    url: hostName + '/v2/authenticate',
    headers: {
      'Content-Type': 'application/json',
      Authorization: 'dummy'
    },
    data: JSON.stringify(request_json_login),
    success: function (data) {
      console.log('login:', { data })
      if (data) {
        //var user_details=data.userDetails;
        token = data.data.token
        connectMedia()
      } else {
        alert(data.status.error)
      }
    }
  })
}

// TO get the selected video type 
$('#videoType').click(function () {
  selectedVideoType = $(this).val()

})

//Calling the restart_video function wherever the video stop 
function restart_video (e) {
  console.log('Hiii')
  $('#playVideo').trigger('click')
}

//Listen the function whenever the video playing stop
var cusDiv = document.getElementById('cusDiv')
cusDiv.addEventListener('restart_video', restart_video)
